#include <fstream>
#include <iostream>

#include "panel.hpp"
#include "string_ext.hpp"

#define BUFFER_LENGTH 5000
using namespace std;

//constructor
panel::panel()
	{
	};
	
//destructor
panel::~panel()
	{
		
	};
	
	
//a uniform method to read the data into 2 string vectors
//the output are two vectors holding the two tables
//also the if there are errors return the error code with 1---can not open file, or file doesn't exit
//			2--- other file errors
int panel::read_data(const string& fileName, const int& line_before_table, std::vector<std::vector<std::string> >* vec1, std::vector<std::vector<std::string> >* vec2)
	{
		//we first have to open the file
		string s;
		int table_no=0;//0 means we are doing metadata, 1 means we are doing table 1, 2 means doing table 2
		bool in_transition=false;//this is flag used to indicate whether we are in the transition area between/before/after
		//table reading, in the metadata section, we allow the empty lines, but for table section, we don't allow empty lines
		//each empty line means a new table, after reading table 2, we are done. and stop
		
		vector<vector<string> > k;
		k=vector<vector<string> >();
		//k.push_back(t);
		vector<vector<string> >* temp=&k;
		string line;
		int nRow = 0;
		ifstream in(fileName.c_str());
		if(!in.is_open())
	  {
	    cout<<"*******ERROR: can not open file \"fname\", please check.......\n";
	    return 1;
	  }
	  cout<<"Start reading the file:\""<<fileName<<"\"........"<<endl;
		int prev_nCol=-1;
	int nCol=0;
	while (getline(in,line)){
		
		string buf[BUFFER_LENGTH];
		chomp_end_ext(line);nRow++;
		//cout<<"reading......row:"<<nRow<<";"<<line.length()<<":"<<line<<endl;
		if(line.length()==0)
		{
			//cout<<"got an empty line........"<<endl;
			
  		if(in_transition)
  			{
  				//cout<<"we are doing transition so far, so we allow empty line in between, keep going........"<<endl;
  				continue;//we allow empty lines in between
  			}
  		else  //not intransition line, then we need to start a new transition
  			{
  				
  				//we are not in a new transition section
  				//cout<<"we need to start a new transition section..........."<<endl;
  				in_transition=true;
  				table_no++;
  				continue;		
  			}
		}
		
		
		//now we have something read in, not an empty line
		if(table_no==0)  //in metadata
			{
				//cout<<"getting the metadata........."<<endl;
				continue;
			}
		//here we read something and already out of metadata section,
		//so start a new table reading and or finish if there are 2 tables already
		//cout<<"got something nwo........need to read........."<<endl;
		if(in_transition)
			{
				in_transition=false;
				//table_no++;
				//cout<<"*******table no is ..."<<table_no<<endl;
				if(table_no==1)
					temp=vec1;
				if(table_no==2)
					temp=vec2;	
				if(table_no>2)
					{
						//we are doing
						cout<<"Finish reading the file..........."<<endl;
						break;
					}
			}
		//put the elements into tables/vectors
		int len=split_ext(line, buf,'\t');
		
		nCol = 0;

		vector<string> word;
		for(int i=0;i<len;i++) 
		  {
		    word.push_back(buf[i]);
		    //cout<<"\treading "<<nCol<<" words an it is "<<word<<endl;
		    nCol++;
		    
		    
			}
		temp->push_back(word);
		//need to take care of non-balanced design or missing values
		//if(prev_nCol!=-1&&nCol<3)
		//  {
		//    cout<<">>>>>>>>>ERROR: the row are not of enough number of elements, please check the file......"<<endl;
		//    return 2;
		//  }
		
		prev_nCol=nCol;
	}
		
		//clean up the files
		in.close();
		
		return 0;
	};

bool panel::check_analyte_name(std::vector<std::vector<std::string> > vec_fi_1,std::vector<std::vector<std::string> > vec_fi_2, 
													std::vector<std::vector<std::string> > vec_expConc_1, std::vector<std::vector<std::string> > vec_expConc_2)
{
		if(vec_fi_1[0].size()!=vec_fi_2[0].size())
			{
				return false;
			}														
			
			if(vec_expConc_1[0].size()!=vec_expConc_2[0].size())
			{
				return false;
			}	
			if(vec_fi_1[0].size()!=vec_expConc_2[0].size())
			{
				return false;
			}	
			
			for(unsigned int i=0;i<vec_fi_1[0].size();i++)
			{
				if(vec_fi_1[0][i].compare(vec_fi_2[0][i])!=0)
					{
						return true;
					}
				if(vec_expConc_1[0][i].compare(vec_expConc_2[0][i])!=0)
					{
						return true;
					}	
				if(vec_fi_1[0][i].compare(vec_expConc_2[0][i])!=0)
					{
						return true;
					}
			}
			
			return true;
};

vector<string > panel::get_analyte_name(vector<vector<string> > vec_fi_1)
{
	vector<string> temp;
	temp=vector<string>();
	for(unsigned int i=3;i<vec_fi_1[0].size();i++)
	{
		temp.push_back(vec_fi_1[0][i]);
	}
	return temp;
};

//this one needs the vectors for fluorescence and expect concentration array, the fluorescence is using the second one
//which is the detailed on, but the fist expect concentration vector (the summarized one) 
int panel::read_cal_data(vector<vector<string> > vec_fi_2, vector<vector<string> > vec_expConc_1, vector<vector<string> >* vec_cal_conc, vector<vector<string> >* vec_cal_fi )
{
		//go throught each well to get "s#" for standard data
		for(unsigned int i=2;i<vec_expConc_1.size();i++)
		{
			if(vec_expConc_1[i][0].at(0)=='s'||vec_expConc_1[i][0].at(0)=='S')
				{
					//this is the one we need, we need to, so put it in there. 
					vec_cal_conc->push_back(vec_expConc_1[i]);
				}
		}
		//now we have to add the fi to the data vec
		string s_temp;
		vector<string> vec_temp_fi;
		vec_temp_fi=vector<string>();
		
		for(unsigned i=0;i<vec_cal_conc->size();i++) //for each standard
		{//go through the fi array to get the element out for this standard
			s_temp=(*vec_cal_conc)[i][0];
			for(unsigned j=2;j<vec_fi_2.size();j++)
			{
				//to
				if(s_temp.compare(vec_fi_2[j][0])==0) //for the standard entry
					{//we found on in the fi input vector, 
						//we need to add the info to the fi output vec 
						//first check to see whether there are something already in there
						bool found_replicates=false;
						for(unsigned k=0;k<vec_cal_fi->size();k++)
						{
							if(s_temp.compare((*vec_cal_fi)[k][0])==0) //there are already entry in there, so this means there are duplicates/replicates, need to append the entry with new info
							
								{
									//vec_temp_fi=vec_fi_2[j];
									//skip the first 3 entries, because the information are metadata
									if(vec_fi_2[j].size()!=(*vec_cal_fi)[k].size())
										{
											//something is wrong
											cout<<"*******ERROR:something is wrong while parseing the information, "
											 <<"the input and output vector is not of the same length (column numbers)"<<endl;
											 return -1;
										}
									for(unsigned m=3;m<vec_fi_2[j].size();m++)
									{
										
										(*vec_cal_fi)[k][m]+="\t";
										(*vec_cal_fi)[k][m]+=vec_fi_2[j][m];
									}
									//finished need to break;
									found_replicates=true;
									break;
								}
						}
						if(!found_replicates)  //this is a new entry, add it to the end of output fi array
							{
								vec_cal_fi->push_back(vec_fi_2[j]);
							}
					}//for matched ones in the vec_fi_2 entry
			}//for search matched ones in the vec_fi_2 input entry
		}//for each standard entry in the vec_cal_conc entry
		return 0;
};

int panel::read_target_data(vector<vector<string> > vec_fi_1, vector<vector<string> > vec_fi_2,  vector<vector<string> >* vec_target_fi )
	{
		//for each unknown entry in the fi file, we need to go throught to add in the output vect
		for(unsigned int i=0;i<vec_fi_2.size();i++)
		{
			//cout<<"doing .......round:"<<i<<endl;
			bool found_replicates=false;
			if(vec_fi_2[i][0].length()!=0&&(vec_fi_2[i][0].at(0)=='x'||vec_fi_2[i][0].at(0)=='X'))//find one entry, need to put this into the output
				{
					//check to see whether we have already one in the array
					//cout<<"@@@found a match........."<<endl;
					for(unsigned j=0;j<vec_target_fi->size();j++)//for each in the output array
					{
						if((*vec_target_fi)[j][0].compare(vec_fi_2[i][0])==0)//found a match in the output we need append
							{
								if((*vec_target_fi)[j].size()!=vec_fi_2[i].size())
									{
										cout<<"******ERROR:"<<endl;
										return -1;
									}
								for(unsigned k=3;k<(*vec_target_fi)[j].size();k++)
								{
									(*vec_target_fi)[j][k]+="\t";
									(*vec_target_fi)[j][k]+=vec_fi_2[i][k];
								}
								found_replicates=true;
								break;
							}
					}//for each entry in the output array
					if(!found_replicates)
					{//add new here
						vec_target_fi->push_back(vec_fi_2[i]);
						bool found_description=false;
						//here we also need to check the vec_fi_1 vec for the description
						for(unsigned int m=0;m<vec_fi_1.size();m++)
						{
							if(vec_fi_2[i][0].compare(vec_fi_1[m][0])==0)
								{//good, this is the one we want its description
									(*vec_target_fi)[vec_target_fi->size()-1][2]=vec_fi_1[m][2];
									found_description=true;
									break;
								}
						}
						if(!found_description)  //did not found at all, so something wrong, leave it alone, but warn the user
							{
								cout<<"*******WARNING>>>, could not found the description of an entry......"<<endl;
								
							}
					}
				}//if loop for match of unknown entry
				
			//cout<<"\t\\\\\\\\done.........."<<endl;
		} //out side loop
		
		return 0;
	};


	int panel::write_cal_data(vector<string> names, vector<vector<string> > vec_cal_conc, vector<vector<string> > vec_cal_fi)
	{
		for(unsigned i=0;i<names.size();i++)
		{
			
			//for each analyte we need to open a file and write it
			ofstream ofs((names[i]+"_calibration.txt").c_str());
			if(!ofs.is_open())
	  	{
	    	cout<<"*******ERROR: can not open file \""<<names[i]<<"\", please check.......\n";
	    	return 1;
	  	} 
	  	//write header first
	  	ofs<<"ID\tName\t"<<names[i]<<"\tMeasure1\tMeasure2\tMeasure3"<<"\r\n";
	  	//then the data;
			for(unsigned j=0;j<vec_cal_conc.size();j++)
			{
				ofs<<vec_cal_conc[j][0]<<"\t"<<vec_cal_conc[j][1]<<"\t"<<vec_cal_conc[j][i+3]<<"\t"<<vec_cal_fi[j][i+3]<<"\r\n";
			}
			ofs.close();
		}
		
		return 0;
	};
	
	int panel::write_target_data(vector<string> names, vector<vector<string> > vec_target)
	{
		for(unsigned i=0;i<names.size();i++)
		{
			//for each analyte we need to open a file and write it
			ofstream ofs((names[i]+"_target.txt").c_str());
			if(!ofs.is_open())
	  	{
	    	cout<<"*******ERROR: can not open file \"fname\", please check.......\n";
	    	return 1;
	  	} 
	  	//write header first
	  	ofs<<"ID\tName\t"<<names[i]<<"\tMeasure1\tMeasure2\tMeasure3"<<"\r\n";
	  	//then the data;
			for(unsigned j=0;j<vec_target.size();j++)
			{
				ofs<<vec_target[j][0]<<"\t"<<vec_target[j][1]<<"\t"<<vec_target[j][2]<<"\t"<<vec_target[j][i+3]<<"\r\n";
			}
			ofs.close();
		}
		
		return 0;
	}
	
	


